## yder 1.1

=== src/Makefile ===
#
# Yder Framework
#
# Makefile used to build the software
#
# Copyright 2015-2016 Nicolas Mora <mail@babelouest.org>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public License
# as published by the Free Software Foundation;
# version 2.1 of the License.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	See the
# GNU GENERAL PUBLIC LICENSE for more details.
#
# You should have received a copy of the GNU General Public
# License along with this library.	If not, see <http://www.gnu.org/licenses/>.
#
PREFIX=/usr/local
CC=gcc
CFLAGS=-c -fPIC -Wall -D_REENTRANT $(ADDITIONALFLAGS)
LIBS=-lc -lorcania
OUTPUT=libyder.so
VERSION=2.0

all: release

libyder.so: yder.o
	$(CC) -shared -Wl,-soname,$(OUTPUT) -o $(OUTPUT).$(VERSION) yder.o $(LIBS)
	ln -sf $(OUTPUT).$(VERSION) $(OUTPUT)

yder.o: yder.h yder.c
	$(CC) $(CFLAGS) yder.c

clean:
	rm -f *.o *.so $(OUTPUT) $(OUTPUT).*

install: all
	cp $(OUTPUT).$(VERSION) $(PREFIX)/lib
	cp yder.h $(PREFIX)/include
	/sbin/ldconfig -r $(PREFIX)

uninstall:
	rm -f $(PREFIX)/lib/$(OUTPUT)
	rm -f $(PREFIX)/lib/$(OUTPUT).*
	rm -f $(PREFIX)/include/yder.h

debug: ADDITIONALFLAGS=-DDEBUG -g -O0

debug: libyder.so

release: ADDITIONALFLAGS=-O3

release: libyder.so

=== debian/changelog ===
yder (1.1-2) unstable; urgency=medium

  * update dependencies

 -- Thorsten Alteholz <debian@alteholz.de>  Mon, 24 Jul 2017 20:18:42 +0200

yder (1.1-1) unstable; urgency=medium

  * Initial release

 -- Thorsten Alteholz <debian@alteholz.de>  Sun, 23 Jul 2017 19:32:33 +0200

=== debian/control ===
Source: yder
Section: devel
Priority: optional
Maintainer: Thorsten Alteholz <debian@alteholz.de>
Build-Depends: debhelper (>= 10)
	, liborcania-dev
	, libjansson-dev
Standards-Version: 4.0.0
Homepage: https://github.com/babelouest/yder
#Vcs-Git: https://anonscm.debian.org/collab-maint/oauth2-server.git
#Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/oauth2-server.git

Package: libyder2.0
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: logging library written in C
 Simple and easy to use logging library. You can log messages to the 
 console, a file or syslog.
 .
 Yder is mono-thread, which mean that you can use only one instance 
 of yder log at the same time in your program.

Package: libyder-dev
Architecture: any
Section: libdevel
Depends: libyder2.0 (= ${binary:Version})
        , ${misc:Depends}
	, liborcania-dev
        , libjansson-dev
Description: logging library written in C - development
 Simple and easy to use logging library. You can log messages to the 
 console, a file or syslog.
 .
 Yder is mono-thread, which mean that you can use only one instance 
 of yder log at the same time in your program.
 .
 This package contains the development files.

## yder 1.1.1

=== Makefile ===
#
# Example program
#
# Makefile used to build all programs
#
# Copyright 2014-2015 Nicolas Mora <mail@babelouest.org>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the MIT License
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU GENERAL PUBLIC LICENSE for more details.
#

LIBYDER_LOCATION=./src
EXAMPLE_LOCATION=./examples
TEST_LOCATION=./test

all: libyder.so

debug:
	cd $(LIBYDER_LOCATION) && $(MAKE) debug

install:
	cd $(LIBYDER_LOCATION) && $(MAKE) install

clean:
	cd $(LIBYDER_LOCATION) && $(MAKE) clean
	cd $(EXAMPLE_LOCATION) && $(MAKE) clean
	cd $(TEST_LOCATION) && $(MAKE) clean

run_test:
	cd $(TEST_LOCATION) && $(MAKE) test

libyder.so:
	cd $(LIBYDER_LOCATION) && $(MAKE)

log_console:
	cd $(EXAMPLE_LOCATION) && $(MAKE) log_console

log_file:
	cd $(EXAMPLE_LOCATION) && $(MAKE) log_file

log_syslog:
	cd $(EXAMPLE_LOCATION) && $(MAKE) log_syslog

log_combined:
	cd $(EXAMPLE_LOCATION) && $(MAKE) log_combined

=== examples/Makefile ===
#
# Example program
#
# Makefile used to build the software
#
# Copyright 2014-2015 Nicolas Mora <mail@babelouest.org>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the MIT License
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU GENERAL PUBLIC LICENSE for more details.
#
CC=gcc
CFLAGS=-c -Wall -D_REENTRANT $(ADDITIONALFLAGS)
YDER_LOCATION=../src
LIBS=-lc -lyder -L$(YDER_LOCATION)
ADDITIONALFLAGS=-O3

all: libyder.so log_console log_syslog log_file

clean:
	rm -f *.o log_console log_syslog log_file log_combined

debug: ADDITIONALFLAGS=-DDEBUG -g -O0

debug: libyder.so log_console log_syslog log_file log_combined

libyder.so:
	cd $(YDER_LOCATION) && $(MAKE)

log_console: log_console.c
	$(CC) -c $(CFLAGS) log_console.c
	$(CC) -o log_console log_console.o $(LIBS)

log_syslog: log_syslog.c
	$(CC) -c $(CFLAGS) log_syslog.c
	$(CC) -o log_syslog log_syslog.o $(LIBS)

log_file: log_file.c
	$(CC) -c $(CFLAGS) log_file.c
	$(CC) -o log_file log_file.o $(LIBS)

log_combined: log_combined.c
	$(CC) -c $(CFLAGS) log_combined.c
	$(CC) -o log_combined log_combined.o $(LIBS)

test: libyder.so log_console log_syslog log_file log_combined
	LD_LIBRARY_PATH=$(YDER_LOCATION):${LD_LIBRARY_PATH} ./log_console
	LD_LIBRARY_PATH=$(YDER_LOCATION):${LD_LIBRARY_PATH} ./log_syslog
	LD_LIBRARY_PATH=$(YDER_LOCATION):${LD_LIBRARY_PATH} ./log_file
	LD_LIBRARY_PATH=$(YDER_LOCATION):${LD_LIBRARY_PATH} ./log_combined

=== src/Makefile ===
--- 
+++ 
@@ -23,7 +23,7 @@
 CFLAGS=-c -fPIC -Wall -D_REENTRANT $(ADDITIONALFLAGS)
 LIBS=-lc -lorcania
 OUTPUT=libyder.so
-VERSION=2.0
+VERSION=1.1.1
 
 all: release
 
@@ -31,19 +31,26 @@
 	$(CC) -shared -Wl,-soname,$(OUTPUT) -o $(OUTPUT).$(VERSION) yder.o $(LIBS)
 	ln -sf $(OUTPUT).$(VERSION) $(OUTPUT)
 
+libyder.a: yder.o
+	ar rcs libyder.a yder.o
+
 yder.o: yder.h yder.c
 	$(CC) $(CFLAGS) yder.c
 
 clean:
-	rm -f *.o *.so $(OUTPUT) $(OUTPUT).*
+	rm -f *.o *.so *.a $(OUTPUT) $(OUTPUT).*
 
 install: all
 	cp $(OUTPUT).$(VERSION) $(PREFIX)/lib
 	cp yder.h $(PREFIX)/include
-	/sbin/ldconfig -r $(PREFIX)
+	-ldconfig
+
+static-install: static
+	cp libyder.a $(PREFIX)/lib
+	cp yder.h $(PREFIX)/include
 
 uninstall:
-	rm -f $(PREFIX)/lib/$(OUTPUT)
+	rm -f $(PREFIX)/lib/$(OUTPUT) $(PREFIX)/lib/libyder.a
 	rm -f $(PREFIX)/lib/$(OUTPUT).*
 	rm -f $(PREFIX)/include/yder.h
 
@@ -54,3 +61,12 @@
 release: ADDITIONALFLAGS=-O3
 
 release: libyder.so
+
+static-debug: ADDITIONALFLAGS=-DDEBUG -g -O0
+
+static-debug: libyder.a
+
+static: ADDITIONALFLAGS=-O3
+
+static: libyder.a
+

=== test/Makefile ===
#
# Glewlwyd OAuth2 Authorization Server
#
# Makefile used to build the software
#
# Copyright 2016 Nicolas Mora <mail@babelouest.org>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU GENERAL PUBLIC LICENSE
# License as published by the Free Software Foundation;
# version 3 of the License.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU GENERAL PUBLIC LICENSE for more details.
#
# You should have received a copy of the GNU General Public
# License along with this program.  If not, see <http://www.gnu.org/licenses/>.
#

CC=gcc
CFLAGS=-Wall -D_REENTRANT -DDEBUG -g -O0
YDER_LOCATION=../src
LIBS=-lc -lorcania -lyder -lcheck -lpthread -lm -lrt -lsubunit -L$(YDER_LOCATION)

all: test

clean:
	rm -f *.o yder_test valgrind.txt

libyder.so:
	cd $(YDER_LOCATION) && $(MAKE) debug

yder_test: yder_test.c
	$(CC) $(CFLAGS) yder_test.c -o yder_test $(LIBS)

test_yder_test: libyder.so yder_test
	-LD_LIBRARY_PATH=$(ORCANIA_LOCATION):${LD_LIBRARY_PATH} ./yder_test

test: test_yder_test

=== debian/changelog ===
yder (1.1.1-1) unstable; urgency=medium

  * New upstream release
  * debian/control: bump standard to 4.1.3 (no changes)
  * debian/control: use dh11

 -- Thorsten Alteholz <debian@alteholz.de>  Sun, 21 Jan 2018 18:01:00 +0100

yder (1.1-3) unstable; urgency=medium

  * debian/control: bump standard to 4.1.0 (no changes)
  * debian/control: add VCS URLs

 -- Thorsten Alteholz <debian@alteholz.de>  Sat, 02 Sep 2017 19:28:42 +0200

=== debian/control ===
Source: yder
Section: devel
Priority: optional
Maintainer: Thorsten Alteholz <debian@alteholz.de>
Build-Depends: debhelper (>= 11)
	, liborcania-dev
	, libjansson-dev
Standards-Version: 4.1.3
Homepage: https://github.com/babelouest/yder
Vcs-Browser: https://anonscm.debian.org/cgit/debian-iot/yder.git
Vcs-Git: https://anonscm.debian.org/git/debian-iot/yder.git

Package: libyder2.0
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: logging library written in C
 Simple and easy to use logging library. You can log messages to the
 console, a file or syslog.
 .
 Yder is mono-thread, which mean that you can use only one instance
 of yder log at the same time in your program.

Package: libyder-dev
Architecture: any
Section: libdevel
Depends: libyder2.0 (= ${binary:Version})
        , ${misc:Depends}
	, liborcania-dev
        , libjansson-dev
Description: logging library written in C - development
 Simple and easy to use logging library. You can log messages to the
 console, a file or syslog.
 .
 Yder is mono-thread, which mean that you can use only one instance
 of yder log at the same time in your program.
 .
 This package contains the development files.

## yder 1.3.3

=== CMakeLists.txt ===
#
# Yder library
#
# CMake file used to build all programs
#
# Copyright 2018 Silvio Clecio <silvioprog@gmail.com>
# Copyright 2018 Nicolas Mora <mail@babelouest.org>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the MIT License
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
#

cmake_minimum_required(VERSION 3.5)

project(yder C)

set(CMAKE_C_STANDARD 99)
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -Werror")

# library info

set(PROJECT_DESCRIPTION "Logging library for C applications")
set(PROJECT_BUGREPORT_PATH "https://github.com/babelouest/yder/issues")

set(LIBRARY_VERSION_MAJOR "1")
set(LIBRARY_VERSION_MINOR "3")
set(LIBRARY_VERSION_PATCH "3")
set(LIBRARY_VERSION "${LIBRARY_VERSION_MAJOR}.${LIBRARY_VERSION_MINOR}.${LIBRARY_VERSION_PATCH}")
set(LIBRARY_SOVERSION "${LIBRARY_VERSION_MAJOR}.${LIBRARY_VERSION_MINOR}")
set(ORCANIA_VERSION_DOWNLOAD "1.2.3")

# cmake modules

set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake-modules)

include(GNUInstallDirs)
include(CheckSymbolExists)

# check if _GNU_SOURCE is available

if (NOT _GNU_SOURCE)
    check_symbol_exists(__GNU_LIBRARY__ "features.h" _GNU_SOURCE)

    if (NOT _GNU_SOURCE)
        unset(_GNU_SOURCE CACHE)
        check_symbol_exists(_GNU_SOURCE "features.h" _GNU_SOURCE)
    endif ()
endif ()

if (_GNU_SOURCE)
    add_definitions(-D_GNU_SOURCE)
endif ()

# directories and source

set(INC_DIR ${CMAKE_CURRENT_SOURCE_DIR}/include)
set(SRC_DIR ${CMAKE_CURRENT_SOURCE_DIR}/src)

include_directories(${INC_DIR})

set(LIB_SRC
        ${INC_DIR}/yder.h # allow many IDEs to find and edit it
        ${SRC_DIR}/yder.c)

# static library

option(BUILD_STATIC "Build static library." OFF)

if (BUILD_STATIC)
    add_library(yder_static STATIC ${LIB_SRC})
    target_compile_definitions(yder_static PUBLIC -DO_STATIC_LIBRARY)
    set_target_properties(yder_static PROPERTIES
            OUTPUT_NAME yder)
endif ()

# shared library

add_library(yder SHARED ${LIB_SRC})
set_target_properties(yder PROPERTIES
        COMPILE_OPTIONS -Wextra
        PUBLIC_HEADER ${INC_DIR}/yder.h
        VERSION "${LIBRARY_VERSION}"
        SOVERSION "${LIBRARY_SOVERSION}")
if (WIN32)
    set_target_properties(yder PROPERTIES SUFFIX "-${LIBRARY_VERSION_MAJOR}.dll")
endif ()

# dependencies

option(WITH_JOURNALD "Check journald." ON)

if (WITH_JOURNALD)
  include(FindSystemd)
  find_package(Systemd REQUIRED)
  if (SYSTEMD_FOUND)
      set(SYSTEMD_LIBRARIES systemd)
      include_directories(${SYSTEMD_INCLUDE_DIRS})
  endif ()
else()
  add_definitions(-DY_DISABLE_JOURNALD)
endif ()

option(CHECK_ORCANIA "Check Orcania library." ON)

if (CHECK_ORCANIA)
	set(Orcania_FIND_QUIETLY ON) # force to find Orcania quietly
	include(FindOrcania)
	find_package(Orcania 1.1 QUIET) # try to find orcania
	if (NOT ORCANIA_FOUND)
			include(DownloadProject)
			download_project(PROJ orcania # ... otherwise, download archive
							URL "https://github.com/babelouest/orcania/archive/v${ORCANIA_VERSION_DOWNLOAD}.tar.gz"
							QUIET)
			add_subdirectory(${orcania_SOURCE_DIR} ${orcania_BINARY_DIR})
			include_directories(${orcania_SOURCE_DIR}/include)
			add_dependencies(yder orcania)
			set(ORCANIA_LIBRARIES orcania)
	endif ()
endif ()

target_link_libraries(yder ${LIBS} ${ORCANIA_LIBRARIES} ${SYSTEMD_LIBRARIES})

# tests

option(BUILD_TESTING "Build the testing tree." OFF) # because we don not use include(CTest)

if (BUILD_TESTING)
    include(FindCheck)
    find_package(Check)
    if (CHECK_FOUND)
        if (NOT WIN32)
            include(FindSubunit)
            find_package(Subunit REQUIRED)
        endif ()

        enable_testing()

        set(CMAKE_CTEST_COMMAND ctest -V)

        set(TST_DIR ${CMAKE_CURRENT_SOURCE_DIR}/test)
        set(LIBS yder ${LIBS} ${CHECK_LIBRARIES})
        if (NOT WIN32)
            find_package(Threads REQUIRED)
            set(LIBS ${LIBS} ${SUBUNIT_LIBRARIES} ${CMAKE_THREAD_LIBS_INIT} m rt)
        endif ()

        set(TESTS yder_test)

        configure_file(
                "${CMAKE_MODULE_PATH}/CTestCustom.cmake.in"
                "${CMAKE_CURRENT_BINARY_DIR}/CTestCustom.cmake"
                @ONLY)

        foreach (t ${TESTS})
            add_executable(${t} EXCLUDE_FROM_ALL ${TST_DIR}/${t}.c)
            target_include_directories(${t} PUBLIC ${TST_DIR})
            target_link_libraries(${t} PUBLIC ${LIBS})
            add_test(NAME ${t}
                    WORKING_DIRECTORY ${TST_DIR}
                    COMMAND ${t})
        endforeach ()
    endif ()
endif ()

# install target

option(INSTALL_HEADER "Install the header files" ON) # Install yder.h or not

configure_file(libyder.pc.in libyder.pc @ONLY)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/libyder.pc
        DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/pkgconfig)

set(TARGETS yder)
if (BUILD_STATIC)
    set(TARGETS ${TARGETS} yder_static)
endif ()

if (INSTALL_HEADER)
    install(TARGETS ${TARGETS}
            RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
            LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
            ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
            PUBLIC_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})
    install(DIRECTORY examples/
            DESTINATION ${CMAKE_INSTALL_DOCDIR}/examples/ COMPONENT runtime)
    install(FILES README.md
            DESTINATION ${CMAKE_INSTALL_DOCDIR} COMPONENT runtime)
else ()
    install(TARGETS ${TARGETS}
            RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
            LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
            ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})
endif ()

# uninstall target

if (NOT TARGET uninstall)
    configure_file(
            "${CMAKE_MODULE_PATH}/CMakeUninstall.cmake.in"
            "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
            IMMEDIATE @ONLY)
    add_custom_target(uninstall
            COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake)
endif ()

# packaging

set(CPACK_PACKAGE_VERSION_MAJOR ${LIBRARY_VERSION_MAJOR})
set(CPACK_PACKAGE_VERSION_MINOR ${LIBRARY_VERSION_MINOR})
set(CPACK_PACKAGE_VERSION_PATCH ${LIBRARY_VERSION_PATCH})

if (INSTALL_HEADER)
    set(PACKAGE_FILE_NAME
            "lib${CMAKE_PROJECT_NAME}-dev_${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}")
else ()
    set(PACKAGE_FILE_NAME
            "lib${CMAKE_PROJECT_NAME}_${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}")
endif ()
set(PACKAGE_IGNORED_FILES
        "${CMAKE_CURRENT_BINARY_DIR}/;/.git/;.gitignore;~$;${CPACK_SOURCE_IGNORE_FILES}")

set(CPACK_GENERATOR "TGZ;DEB")
set(CPACK_DEBIAN_PACKAGE_NAME "libyder")
set(CPACK_DEBIAN_PACKAGE_MAINTAINER "mail@babelouest.org")
set(CPACK_DEBIAN_PACKAGE_DESCRIPTION ${PROJECT_DESCRIPTION})
set(CPACK_DEBIAN_PACKAGE_HOMEPAGE "https://github.com/babelouest/yder")
set(CPACK_DEBIAN_PACKAGE_DEPENDS "libc6 (>= 2.4), liborcania (>= 1.2)")
set(CPACK_PACKAGE_FILE_NAME ${PACKAGE_FILE_NAME})

set(CPACK_SOURCE_GENERATOR "TGZ")
set(CPACK_SOURCE_PACKAGE_FILE_NAME ${PACKAGE_FILE_NAME})
set(CPACK_SOURCE_IGNORE_FILES ${PACKAGE_IGNORED_FILES})

include(CPack)

add_custom_target(dist_y
        COMMAND ${CMAKE_MAKE_PROGRAM} package_source)

=== examples/Makefile ===
--- 
+++ 
@@ -18,15 +18,20 @@
 YDER_LOCATION=../src
 LIBS=-lc -lyder -L$(YDER_LOCATION)
 ADDITIONALFLAGS=-O3
+TARGET=log_console log_syslog log_file log_combined
 
-all: libyder.so log_console log_syslog log_file
+ifndef Y_DISABLE_JOURNALD
+	TARGET+= log_journald
+endif
+
+all: libyder.so $(TARGET)
 
 clean:
-	rm -f *.o log_console log_syslog log_file log_combined
+	rm -f *.o log_console log_syslog log_file log_combined log_journald
 
 debug: ADDITIONALFLAGS=-DDEBUG -g -O0
 
-debug: libyder.so log_console log_syslog log_file log_combined
+debug: libyder.so $(TARGET)
 
 libyder.so:
 	cd $(YDER_LOCATION) && $(MAKE)
@@ -39,6 +44,10 @@
 	$(CC) -c $(CFLAGS) log_syslog.c
 	$(CC) -o log_syslog log_syslog.o $(LIBS)
 
+log_journald: log_journald.c
+	$(CC) -c $(CFLAGS) log_journald.c
+	$(CC) -o log_journald log_journald.o $(LIBS)
+
 log_file: log_file.c
 	$(CC) -c $(CFLAGS) log_file.c
 	$(CC) -o log_file log_file.o $(LIBS)
@@ -47,8 +56,45 @@
 	$(CC) -c $(CFLAGS) log_combined.c
 	$(CC) -o log_combined log_combined.o $(LIBS)
 
-test: libyder.so log_console log_syslog log_file log_combined
+test_console: libyder.so $(TARGET)
+	LD_LIBRARY_PATH=$(YDER_LOCATION):${LD_LIBRARY_PATH} ./log_console
+
+test_syslog: libyder.so $(TARGET)
+	LD_LIBRARY_PATH=$(YDER_LOCATION):${LD_LIBRARY_PATH} ./log_syslog
+
+test_file: libyder.so $(TARGET)
+	LD_LIBRARY_PATH=$(YDER_LOCATION):${LD_LIBRARY_PATH} ./log_file
+
+test_combined: libyder.so $(TARGET)
+	LD_LIBRARY_PATH=$(YDER_LOCATION):${LD_LIBRARY_PATH} ./log_combined
+
+test_journald: libyder.so $(TARGET)
+	LD_LIBRARY_PATH=$(YDER_LOCATION):${LD_LIBRARY_PATH} ./log_journald
+
+ifndef Y_DISABLE_JOURNALD
+test: libyder.so $(TARGET)
 	LD_LIBRARY_PATH=$(YDER_LOCATION):${LD_LIBRARY_PATH} ./log_console
 	LD_LIBRARY_PATH=$(YDER_LOCATION):${LD_LIBRARY_PATH} ./log_syslog
 	LD_LIBRARY_PATH=$(YDER_LOCATION):${LD_LIBRARY_PATH} ./log_file
 	LD_LIBRARY_PATH=$(YDER_LOCATION):${LD_LIBRARY_PATH} ./log_combined
+	LD_LIBRARY_PATH=$(YDER_LOCATION):${LD_LIBRARY_PATH} ./log_journald
+else
+	LD_LIBRARY_PATH=$(YDER_LOCATION):${LD_LIBRARY_PATH} ./log_console
+	LD_LIBRARY_PATH=$(YDER_LOCATION):${LD_LIBRARY_PATH} ./log_syslog
+	LD_LIBRARY_PATH=$(YDER_LOCATION):${LD_LIBRARY_PATH} ./log_file
+	LD_LIBRARY_PATH=$(YDER_LOCATION):${LD_LIBRARY_PATH} ./log_combined
+endif
+
+ifndef Y_DISABLE_JOURNALD
+memcheck: libyder.so log_console log_syslog log_file log_combined log_journald
+	LD_LIBRARY_PATH=$(YDER_LOCATION):${LD_LIBRARY_PATH} valgrind --tool=memcheck --leak-check=full --show-leak-kinds=all ./log_console 2>valgrind.txt
+	LD_LIBRARY_PATH=$(YDER_LOCATION):${LD_LIBRARY_PATH} valgrind --tool=memcheck --leak-check=full --show-leak-kinds=all ./log_syslog 2>>valgrind.txt
+	LD_LIBRARY_PATH=$(YDER_LOCATION):${LD_LIBRARY_PATH} valgrind --tool=memcheck --leak-check=full --show-leak-kinds=all ./log_file 2>>valgrind.txt
+	LD_LIBRARY_PATH=$(YDER_LOCATION):${LD_LIBRARY_PATH} valgrind --tool=memcheck --leak-check=full --show-leak-kinds=all ./log_combined 2>>valgrind.txt
+	LD_LIBRARY_PATH=$(YDER_LOCATION):${LD_LIBRARY_PATH} valgrind --tool=memcheck --leak-check=full --show-leak-kinds=all ./log_journald 2>>valgrind.txt
+else
+	LD_LIBRARY_PATH=$(YDER_LOCATION):${LD_LIBRARY_PATH} valgrind --tool=memcheck --leak-check=full --show-leak-kinds=all ./log_console 2>valgrind.txt
+	LD_LIBRARY_PATH=$(YDER_LOCATION):${LD_LIBRARY_PATH} valgrind --tool=memcheck --leak-check=full --show-leak-kinds=all ./log_syslog 2>>valgrind.txt
+	LD_LIBRARY_PATH=$(YDER_LOCATION):${LD_LIBRARY_PATH} valgrind --tool=memcheck --leak-check=full --show-leak-kinds=all ./log_file 2>>valgrind.txt
+	LD_LIBRARY_PATH=$(YDER_LOCATION):${LD_LIBRARY_PATH} valgrind --tool=memcheck --leak-check=full --show-leak-kinds=all ./log_combined 2>>valgrind.txt
+endif

=== src/Makefile ===
#
# Yder Framework
#
# Makefile used to build the software
#
# Copyright 2015-2018 Nicolas Mora <mail@babelouest.org>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public License
# as published by the Free Software Foundation;
# version 2.1 of the License.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	See the
# GNU GENERAL PUBLIC LICENSE for more details.
#
# You should have received a copy of the GNU General Public
# License along with this library.	If not, see <http://www.gnu.org/licenses/>.
#
DESTDIR=/usr/local
CC=gcc
CFLAGS+=-c -fPIC -Wall -D_REENTRANT $(ADDITIONALFLAGS)
LIBS=-lc -lorcania $(ADDITIONALLIBS)
OUTPUT=libyder.so
VERSION=1.3.3

ifndef Y_DISABLE_JOURNALD
	LIBS+=-lsystemd
endif

all: release

libyder.so: yder.o
	$(CC) -shared -fPIC -Wl,-soname,$(OUTPUT) -o $(OUTPUT).$(VERSION) yder.o $(LIBS) $(LDFLAGS)
	ln -sf $(OUTPUT).$(VERSION) $(OUTPUT)

libyder.a: yder.o
	ar rcs libyder.a yder.o

yder.o: ../include/yder.h yder.c
	$(CC) $(CFLAGS) $(CPPFLAGS) yder.c

clean:
	rm -f *.o *.so *.a $(OUTPUT) $(OUTPUT).*

install: all
	cp $(OUTPUT).$(VERSION) $(DESTDIR)/lib
	cp ../include/yder.h $(DESTDIR)/include
	-ldconfig

static-install: static
	cp libyder.a $(DESTDIR)/lib
	cp ../include/yder.h $(DESTDIR)/include

uninstall:
	rm -f $(DESTDIR)/lib/$(OUTPUT) $(DESTDIR)/lib/libyder.a
	rm -f $(DESTDIR)/lib/$(OUTPUT).*
	rm -f $(DESTDIR)/include/yder.h

debug: ADDITIONALFLAGS=-DDEBUG -g -O0

debug: libyder.so

release: ADDITIONALFLAGS=-O3

release: libyder.so

static-debug: ADDITIONALFLAGS=-DDEBUG -g -O0

static-debug: libyder.a

static: ADDITIONALFLAGS=-O3

static: libyder.a

=== test/Makefile ===
--- 
+++ 
@@ -36,6 +36,6 @@
 	$(CC) $(CFLAGS) yder_test.c -o yder_test $(LIBS)
 
 test_yder_test: libyder.so yder_test
-	-LD_LIBRARY_PATH=$(ORCANIA_LOCATION):${LD_LIBRARY_PATH} ./yder_test
+	-LD_LIBRARY_PATH=$(YDER_LOCATION):${LD_LIBRARY_PATH} ./yder_test
 
 test: test_yder_test

=== debian/changelog ===
yder (1.3.3-2build1) cosmic; urgency=medium

  * No-change rebuild for liborcania soname change.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 06 May 2018 10:02:10 +0200

yder (1.3.3-2) unstable; urgency=medium

  * Install examples and README.md
  * Fix lintian warnings

 -- Nicolas Mora <nicolas@babelouest.org>  Tue, 24 Apr 2018 11:57:11 -0400

yder (1.3.3-1) unstable; urgency=medium

  * New upstream release
  * debian/rules: use cmake as buildsystem
  * debian/copyright: add cmake scripts

 -- Nicolas Mora <nicolas@babelouest.org>  Sat, 21 Apr 2018 08:23:11 -0400

=== debian/control ===
--- 
+++ 
@@ -1,14 +1,18 @@
 Source: yder
 Section: devel
 Priority: optional
-Maintainer: Thorsten Alteholz <debian@alteholz.de>
+Maintainer: Debian IoT Maintainers <debian-iot-maintainers@lists.alioth.debian.org>
+Uploaders: Thorsten Alteholz <debian@alteholz.de>
+          , Nicolas Mora <nicolas@babelouest.org>
 Build-Depends: debhelper (>= 11)
 	, liborcania-dev
 	, libjansson-dev
+  , libsystemd-dev
+  , cmake
 Standards-Version: 4.1.3
 Homepage: https://github.com/babelouest/yder
-Vcs-Browser: https://anonscm.debian.org/cgit/debian-iot/yder.git
-Vcs-Git: https://anonscm.debian.org/git/debian-iot/yder.git
+Vcs-Browser: https://salsa.debian.org/debian-iot-team/oauth2/yder.git
+Vcs-Git: https://salsa.debian.org/debian-iot-team/oauth2/yder.git
 
 Package: libyder2.0
 Architecture: any
@@ -26,8 +30,9 @@
 Section: libdevel
 Depends: libyder2.0 (= ${binary:Version})
         , ${misc:Depends}
-	, liborcania-dev
+        , liborcania-dev
         , libjansson-dev
+        , libsystemd-dev
 Description: logging library written in C - development
  Simple and easy to use logging library. You can log messages to the
  console, a file or syslog.

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1


# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed


%:
	dh $@ --buildsystem=cmake --builddirectory=build

override_dh_auto_install:
	echo dh_auto_install

override_dh_auto_configure:
	dh_auto_configure -- $(ARGS) --no-warn-unused-cli
	dh_installexamples

## yder 1.4.4

=== CMakeLists.txt ===
--- 
+++ 
@@ -24,14 +24,16 @@
 # library info
 
 set(PROJECT_DESCRIPTION "Logging library for C applications")
+set(PROJECT_HOMEPAGE_URL "https://github.com/babelouest/yder/")
 set(PROJECT_BUGREPORT_PATH "https://github.com/babelouest/yder/issues")
-
 set(LIBRARY_VERSION_MAJOR "1")
-set(LIBRARY_VERSION_MINOR "3")
-set(LIBRARY_VERSION_PATCH "3")
+set(LIBRARY_VERSION_MINOR "4")
+set(LIBRARY_VERSION_PATCH "4")
+set(PROJECT_VERSION "${LIBRARY_VERSION_MAJOR}.${LIBRARY_VERSION_MINOR}.${LIBRARY_VERSION_PATCH}")
+
 set(LIBRARY_VERSION "${LIBRARY_VERSION_MAJOR}.${LIBRARY_VERSION_MINOR}.${LIBRARY_VERSION_PATCH}")
 set(LIBRARY_SOVERSION "${LIBRARY_VERSION_MAJOR}.${LIBRARY_VERSION_MINOR}")
-set(ORCANIA_VERSION_DOWNLOAD "1.2.3")
+set(ORCANIA_VERSION_DOWNLOAD "1.2.8")
 
 # cmake modules
 
@@ -65,29 +67,6 @@
 set(LIB_SRC
         ${INC_DIR}/yder.h # allow many IDEs to find and edit it
         ${SRC_DIR}/yder.c)
-
-# static library
-
-option(BUILD_STATIC "Build static library." OFF)
-
-if (BUILD_STATIC)
-    add_library(yder_static STATIC ${LIB_SRC})
-    target_compile_definitions(yder_static PUBLIC -DO_STATIC_LIBRARY)
-    set_target_properties(yder_static PROPERTIES
-            OUTPUT_NAME yder)
-endif ()
-
-# shared library
-
-add_library(yder SHARED ${LIB_SRC})
-set_target_properties(yder PROPERTIES
-        COMPILE_OPTIONS -Wextra
-        PUBLIC_HEADER ${INC_DIR}/yder.h
-        VERSION "${LIBRARY_VERSION}"
-        SOVERSION "${LIBRARY_SOVERSION}")
-if (WIN32)
-    set_target_properties(yder PROPERTIES SUFFIX "-${LIBRARY_VERSION_MAJOR}.dll")
-endif ()
 
 # dependencies
 
@@ -99,36 +78,79 @@
   if (SYSTEMD_FOUND)
       set(SYSTEMD_LIBRARIES systemd)
       include_directories(${SYSTEMD_INCLUDE_DIRS})
+      set(DISABLE_JOURNALD OFF)
   endif ()
 else()
   add_definitions(-DY_DISABLE_JOURNALD)
-endif ()
-
-option(CHECK_ORCANIA "Check Orcania library." ON)
-
-if (CHECK_ORCANIA)
-	set(Orcania_FIND_QUIETLY ON) # force to find Orcania quietly
-	include(FindOrcania)
-	find_package(Orcania 1.1 QUIET) # try to find orcania
-	if (NOT ORCANIA_FOUND)
-			include(DownloadProject)
-			download_project(PROJ orcania # ... otherwise, download archive
-							URL "https://github.com/babelouest/orcania/archive/v${ORCANIA_VERSION_DOWNLOAD}.tar.gz"
-							QUIET)
-			add_subdirectory(${orcania_SOURCE_DIR} ${orcania_BINARY_DIR})
-			include_directories(${orcania_SOURCE_DIR}/include)
-			add_dependencies(yder orcania)
-			set(ORCANIA_LIBRARIES orcania)
-	endif ()
+  set(DISABLE_JOURNALD ON)
+endif ()
+
+# shared library
+
+add_library(yder SHARED ${LIB_SRC})
+set_target_properties(yder PROPERTIES
+        COMPILE_OPTIONS -Wextra
+        PUBLIC_HEADER "${INC_DIR}/yder.h;${PROJECT_BINARY_DIR}/yder-cfg.h"
+        VERSION "${LIBRARY_VERSION}"
+        SOVERSION "${LIBRARY_SOVERSION}")
+if (WIN32)
+    set_target_properties(yder PROPERTIES SUFFIX "-${LIBRARY_VERSION_MAJOR}.dll")
 endif ()
 
 target_link_libraries(yder ${LIBS} ${ORCANIA_LIBRARIES} ${SYSTEMD_LIBRARIES})
 
+# static library
+
+option(BUILD_STATIC "Build static library." OFF)
+
+if (BUILD_STATIC)
+    add_library(yder_static STATIC ${LIB_SRC})
+    target_compile_definitions(yder_static PUBLIC -DO_STATIC_LIBRARY)
+    set_target_properties(yder_static PROPERTIES
+            OUTPUT_NAME yder)
+endif ()
+
+option (SEARCH_ORCANIA "Search for Orcania library" ON)
+if (SEARCH_ORCANIA)
+    set(Orcania_FIND_QUIETLY ON) # force to find Orcania quietly
+    include(FindOrcania)
+    find_package(Orcania 1.1 QUIET) # try to find orcania
+    if (NOT ORCANIA_FOUND)
+        include(DownloadProject)
+        download_project(PROJ orcania # ... otherwise, download archive
+            URL "https://github.com/babelouest/orcania/archive/v${ORCANIA_VERSION_DOWNLOAD}.tar.gz"
+            QUIET)
+        add_subdirectory(${orcania_SOURCE_DIR} ${orcania_BINARY_DIR})
+        include_directories(${orcania_SOURCE_DIR}/include)
+        include_directories(${orcania_BINARY_DIR})
+        add_dependencies(yder orcania)
+        set(ORCANIA_LIBRARIES orcania)
+        set(LIBS ${LIBS} ${ORCANIA_LIBRARIES})
+    else()
+        set(LIBS ${LIBS} ${ORCANIA_LIBRARIES})
+        include_directories(${ORCANIA_INCLUDE_DIRS})
+        include_directories(${orcania_BINARY_DIR})
+    endif ()
+endif ()
+
+if (WITH_JOURNALD)
+  set(PKGCONF_REQ "")
+  set(PKGCONF_REQ_PRIVATE "libsystemd, liborcania")
+else ()
+  set(PKGCONF_REQ "")
+  set(PKGCONF_REQ_PRIVATE "liborcania")
+endif ()
+
+# build yder-cfg.h file
+configure_file(${INC_DIR}/yder-cfg.h.in ${PROJECT_BINARY_DIR}/yder-cfg.h)
+set (CMAKE_EXTRA_INCLUDE_FILES ${PROJECT_BINARY_DIR})
+include_directories(${PROJECT_BINARY_DIR})
+
 # tests
 
-option(BUILD_TESTING "Build the testing tree." OFF) # because we don not use include(CTest)
-
-if (BUILD_TESTING)
+option(BUILD_YDER_TESTING "Build the testing tree." OFF) # because we don not use include(CTest)
+
+if (BUILD_YDER_TESTING)
     include(FindCheck)
     find_package(Check)
     if (CHECK_FOUND)
@@ -173,7 +195,7 @@
 configure_file(libyder.pc.in libyder.pc @ONLY)
 
 install(FILES ${CMAKE_CURRENT_BINARY_DIR}/libyder.pc
-        DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/pkgconfig)
+        DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)
 
 set(TARGETS yder)
 if (BUILD_STATIC)
@@ -224,12 +246,25 @@
 set(PACKAGE_IGNORED_FILES
         "${CMAKE_CURRENT_BINARY_DIR}/;/.git/;.gitignore;~$;${CPACK_SOURCE_IGNORE_FILES}")
 
+set(CPACK_PACKAGE_NAME "libyder")
+set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "Logging library for C applications")
 set(CPACK_GENERATOR "TGZ;DEB")
-set(CPACK_DEBIAN_PACKAGE_NAME "libyder")
+set(CPACK_PACKAGE_VERSION_MAJOR ${LIBRARY_VERSION_MAJOR})
+set(CPACK_PACKAGE_VERSION_MINOR ${LIBRARY_VERSION_MINOR})
+set(CPACK_PACKAGE_VERSION_PATCH ${LIBRARY_VERSION_PATCH})
+
+option(BUILD_RPM "Build a RPM for your system" OFF)
+if (BUILD_RPM)
+  set(CPACK_GENERATOR "TGZ;DEB;RPM")
+  set(CPACK_RPM_PACKAGE_LICENSE "LGPL")
+  set(CPACK_RPM_PACKAGE_URL "http://babelouest.github.io/yder/")
+endif ()
+
 set(CPACK_DEBIAN_PACKAGE_MAINTAINER "mail@babelouest.org")
-set(CPACK_DEBIAN_PACKAGE_DESCRIPTION ${PROJECT_DESCRIPTION})
-set(CPACK_DEBIAN_PACKAGE_HOMEPAGE "https://github.com/babelouest/yder")
 set(CPACK_DEBIAN_PACKAGE_DEPENDS "libc6 (>= 2.4), liborcania (>= 1.2)")
+if (WITH_SYSTEMD)
+  set(CPACK_DEBIAN_PACKAGE_DEPENDS "${CPACK_DEBIAN_PACKAGE_DEPENDS}, libsystemd0")
+endif ()
 set(CPACK_PACKAGE_FILE_NAME ${PACKAGE_FILE_NAME})
 
 set(CPACK_SOURCE_GENERATOR "TGZ")
@@ -240,3 +275,9 @@
 
 add_custom_target(dist_y
         COMMAND ${CMAKE_MAKE_PROGRAM} package_source)
+
+message(STATUS "Journald support: ${WITH_JOURNALD}")
+message(STATUS "Build static library: ${BUILD_STATIC}")
+message(STATUS "Build testing tree: ${BUILD_ULFIUS_TESTING}")
+message(STATUS "Install the header files: ${INSTALL_HEADER}")
+message(STATUS "Build RPM package: ${BUILD_RPM}")

=== Makefile ===
--- 
+++ 
@@ -3,7 +3,7 @@
 #
 # Makefile used to build all programs
 #
-# Copyright 2014-2015 Nicolas Mora <mail@babelouest.org>
+# Copyright 2014-2018 Nicolas Mora <mail@babelouest.org>
 #
 # This program is free software; you can redistribute it and/or
 # modify it under the terms of the MIT License

=== examples/Makefile ===
--- 
+++ 
@@ -14,11 +14,12 @@
 # GNU GENERAL PUBLIC LICENSE for more details.
 #
 CC=gcc
-CFLAGS=-c -Wall -D_REENTRANT $(ADDITIONALFLAGS)
+CFLAGS=-c -Wall -D_REENTRANT $(ADDITIONALFLAGS) -I$(INCLUDE_LOCATION)
 YDER_LOCATION=../src
+INCLUDE_LOCATION=../include
 LIBS=-lc -lyder -L$(YDER_LOCATION)
 ADDITIONALFLAGS=-O3
-TARGET=log_console log_syslog log_file log_combined
+TARGET=log_console log_syslog log_file log_combined log_callback
 
 ifndef Y_DISABLE_JOURNALD
 	TARGET+= log_journald
@@ -27,7 +28,7 @@
 all: libyder.so $(TARGET)
 
 clean:
-	rm -f *.o log_console log_syslog log_file log_combined log_journald
+	rm -f *.o log_console log_syslog log_file log_combined log_journald log_callback
 
 debug: ADDITIONALFLAGS=-DDEBUG -g -O0
 
@@ -56,20 +57,27 @@
 	$(CC) -c $(CFLAGS) log_combined.c
 	$(CC) -o log_combined log_combined.o $(LIBS)
 
-test_console: libyder.so $(TARGET)
+log_callback: log_callback.c
+	$(CC) -c $(CFLAGS) log_callback.c
+	$(CC) -o log_callback log_callback.o $(LIBS)
+
+test_console: libyder.so log_console
 	LD_LIBRARY_PATH=$(YDER_LOCATION):${LD_LIBRARY_PATH} ./log_console
 
-test_syslog: libyder.so $(TARGET)
+test_syslog: libyder.so log_syslog
 	LD_LIBRARY_PATH=$(YDER_LOCATION):${LD_LIBRARY_PATH} ./log_syslog
 
-test_file: libyder.so $(TARGET)
+test_file: libyder.so log_file
 	LD_LIBRARY_PATH=$(YDER_LOCATION):${LD_LIBRARY_PATH} ./log_file
 
-test_combined: libyder.so $(TARGET)
+test_combined: libyder.so log_combined
 	LD_LIBRARY_PATH=$(YDER_LOCATION):${LD_LIBRARY_PATH} ./log_combined
 
-test_journald: libyder.so $(TARGET)
+test_journald: libyder.so log_journald
 	LD_LIBRARY_PATH=$(YDER_LOCATION):${LD_LIBRARY_PATH} ./log_journald
+
+test_callback: libyder.so log_callback
+	LD_LIBRARY_PATH=$(YDER_LOCATION):${LD_LIBRARY_PATH} ./log_callback
 
 ifndef Y_DISABLE_JOURNALD
 test: libyder.so $(TARGET)
@@ -78,23 +86,27 @@
 	LD_LIBRARY_PATH=$(YDER_LOCATION):${LD_LIBRARY_PATH} ./log_file
 	LD_LIBRARY_PATH=$(YDER_LOCATION):${LD_LIBRARY_PATH} ./log_combined
 	LD_LIBRARY_PATH=$(YDER_LOCATION):${LD_LIBRARY_PATH} ./log_journald
+	LD_LIBRARY_PATH=$(YDER_LOCATION):${LD_LIBRARY_PATH} ./log_callback
 else
 	LD_LIBRARY_PATH=$(YDER_LOCATION):${LD_LIBRARY_PATH} ./log_console
 	LD_LIBRARY_PATH=$(YDER_LOCATION):${LD_LIBRARY_PATH} ./log_syslog
 	LD_LIBRARY_PATH=$(YDER_LOCATION):${LD_LIBRARY_PATH} ./log_file
 	LD_LIBRARY_PATH=$(YDER_LOCATION):${LD_LIBRARY_PATH} ./log_combined
+	LD_LIBRARY_PATH=$(YDER_LOCATION):${LD_LIBRARY_PATH} ./log_callback
 endif
 
 ifndef Y_DISABLE_JOURNALD
-memcheck: libyder.so log_console log_syslog log_file log_combined log_journald
+memcheck: libyder.so $(TARGET)
 	LD_LIBRARY_PATH=$(YDER_LOCATION):${LD_LIBRARY_PATH} valgrind --tool=memcheck --leak-check=full --show-leak-kinds=all ./log_console 2>valgrind.txt
 	LD_LIBRARY_PATH=$(YDER_LOCATION):${LD_LIBRARY_PATH} valgrind --tool=memcheck --leak-check=full --show-leak-kinds=all ./log_syslog 2>>valgrind.txt
 	LD_LIBRARY_PATH=$(YDER_LOCATION):${LD_LIBRARY_PATH} valgrind --tool=memcheck --leak-check=full --show-leak-kinds=all ./log_file 2>>valgrind.txt
 	LD_LIBRARY_PATH=$(YDER_LOCATION):${LD_LIBRARY_PATH} valgrind --tool=memcheck --leak-check=full --show-leak-kinds=all ./log_combined 2>>valgrind.txt
 	LD_LIBRARY_PATH=$(YDER_LOCATION):${LD_LIBRARY_PATH} valgrind --tool=memcheck --leak-check=full --show-leak-kinds=all ./log_journald 2>>valgrind.txt
+	LD_LIBRARY_PATH=$(YDER_LOCATION):${LD_LIBRARY_PATH} valgrind --tool=memcheck --leak-check=full --show-leak-kinds=all ./log_callback 2>>valgrind.txt
 else
 	LD_LIBRARY_PATH=$(YDER_LOCATION):${LD_LIBRARY_PATH} valgrind --tool=memcheck --leak-check=full --show-leak-kinds=all ./log_console 2>valgrind.txt
 	LD_LIBRARY_PATH=$(YDER_LOCATION):${LD_LIBRARY_PATH} valgrind --tool=memcheck --leak-check=full --show-leak-kinds=all ./log_syslog 2>>valgrind.txt
 	LD_LIBRARY_PATH=$(YDER_LOCATION):${LD_LIBRARY_PATH} valgrind --tool=memcheck --leak-check=full --show-leak-kinds=all ./log_file 2>>valgrind.txt
 	LD_LIBRARY_PATH=$(YDER_LOCATION):${LD_LIBRARY_PATH} valgrind --tool=memcheck --leak-check=full --show-leak-kinds=all ./log_combined 2>>valgrind.txt
+	LD_LIBRARY_PATH=$(YDER_LOCATION):${LD_LIBRARY_PATH} valgrind --tool=memcheck --leak-check=full --show-leak-kinds=all ./log_callback 2>>valgrind.txt
 endif

=== src/Makefile ===
--- 
+++ 
@@ -19,44 +19,63 @@
 # License along with this library.	If not, see <http://www.gnu.org/licenses/>.
 #
 DESTDIR=/usr/local
+YDER_INCLUDE=../include
+CONFIG_TEMPLATE=$(YDER_INCLUDE)/yder-cfg.h.in
+CONFIG_FILE=$(YDER_INCLUDE)/yder-cfg.h
 CC=gcc
-CFLAGS+=-c -fPIC -Wall -D_REENTRANT $(ADDITIONALFLAGS)
+CFLAGS+=-c -fPIC -Wall -D_REENTRANT -I$(YDER_INCLUDE) $(ADDITIONALFLAGS) $(CPPFLAGS)
 LIBS=-lc -lorcania $(ADDITIONALLIBS)
 OUTPUT=libyder.so
-VERSION=1.3.3
+VERSION=1.4.4
 
 ifndef Y_DISABLE_JOURNALD
+	DISABLE_JOURNALD=0
 	LIBS+=-lsystemd
+else
+	DISABLE_JOURNALD=1
 endif
 
 all: release
 
-libyder.so: yder.o
+$(CONFIG_FILE):
+	@cp $(CONFIG_TEMPLATE) $(CONFIG_FILE)
+	@sed -i -e 's/$${PROJECT_VERSION}/$(VERSION)/g' $(CONFIG_FILE)        
+	@if [ "$(DISABLE_JOURNALD)" = "1" ]; then \
+		sed -i -e 's/\#cmakedefine DISABLE_JOURNALD/\#define Y_DISABLE_JOURNALD/g' $(CONFIG_FILE); \
+	else \
+		sed -i -e 's/\#cmakedefine DISABLE_JOURNALD/\/* #undef Y_DISABLE_JOURNALD *\//g' $(CONFIG_FILE); \
+	fi
+	@echo Config file $(CONFIG_FILE) generated 
+
+libyder.so: $(CONFIG_FILE) yder.o
 	$(CC) -shared -fPIC -Wl,-soname,$(OUTPUT) -o $(OUTPUT).$(VERSION) yder.o $(LIBS) $(LDFLAGS)
 	ln -sf $(OUTPUT).$(VERSION) $(OUTPUT)
 
-libyder.a: yder.o
+libyder.a: $(CONFIG_FILE) yder.o
 	ar rcs libyder.a yder.o
 
-yder.o: ../include/yder.h yder.c
+yder.o: $(YDER_INCLUDE)/yder.h yder.c
 	$(CC) $(CFLAGS) $(CPPFLAGS) yder.c
 
 clean:
-	rm -f *.o *.so *.a $(OUTPUT) $(OUTPUT).*
+	rm -f *.o *.so *.a $(OUTPUT) $(OUTPUT).* $(YDER_INCLUDE)/yder-cfg.h
 
 install: all
-	cp $(OUTPUT).$(VERSION) $(DESTDIR)/lib
-	cp ../include/yder.h $(DESTDIR)/include
+	install $(OUTPUT).$(VERSION) $(DESTDIR)/lib
+	install -m644 $(YDER_INCLUDE)/yder.h $(DESTDIR)/include
+	install -m644 $(CONFIG_FILE) $(DESTDIR)/include
 	-ldconfig
 
 static-install: static
-	cp libyder.a $(DESTDIR)/lib
-	cp ../include/yder.h $(DESTDIR)/include
+	install libyder.a $(DESTDIR)/lib
+	install -m644 $(YDER_INCLUDE)/yder.h $(DESTDIR)/include
+	install -m644 $(CONFIG_FILE) $(DESTDIR)/include
 
 uninstall:
 	rm -f $(DESTDIR)/lib/$(OUTPUT) $(DESTDIR)/lib/libyder.a
 	rm -f $(DESTDIR)/lib/$(OUTPUT).*
 	rm -f $(DESTDIR)/include/yder.h
+	rm -f $(DESTDIR)/include/yder-cfg.h
 
 debug: ADDITIONALFLAGS=-DDEBUG -g -O0

=== test/Makefile ===
--- 
+++ 
@@ -20,8 +20,9 @@
 #
 
 CC=gcc
-CFLAGS=-Wall -D_REENTRANT -DDEBUG -g -O0
+CFLAGS=-Wall -D_REENTRANT -DDEBUG -g -O0 -I$(INCLUDE_LOCATION)
 YDER_LOCATION=../src
+INCLUDE_LOCATION=../include
 LIBS=-lc -lorcania -lyder -lcheck -lpthread -lm -lrt -lsubunit -L$(YDER_LOCATION)
 
 all: test

=== debian/changelog ===
yder (1.4.4-6) unstable; urgency=medium

  * debian/control: bump standard to 4.4.0 (no changes)
  * debian/tests: Fix debci unit-test

 -- Nicolas Mora <nicolas@babelouest.org>  Sat, 31 Aug 2019 20:05:05 -0400

yder (1.4.4-5) unstable; urgency=medium

  * debian/patches/cmake.patch: remove PKGCONF_REQ_PRIVATE patch
                                (Closes: #926317)

 -- Nicolas Mora <nicolas@babelouest.org>  Thu, 04 Apr 2019 19:22:12 -0400

yder (1.4.4-4) unstable; urgency=medium

  * debian/tests/control: fix autopkgtest dependencies
  * debian/rules: clarify dh_auto_configure to explicitly declare options
                  build tests from cmake instead of Makefile

 -- Nicolas Mora <nicolas@babelouest.org>  Sat, 05 Jan 2019 09:57:18 -0500

yder (1.4.4-3) unstable; urgency=medium

  * debian/control: set libsystemd-dev dependency only for linux
  * debian/control: upgrade Standards-Version to 4.3.0 (no change)
  * debian/rules: disable journald support for non linux os (Closes: #912399)

 -- Nicolas Mora <nicolas@babelouest.org>  Tue, 01 Jan 2019 08:48:06 -0500

yder (1.4.4-2) unstable; urgency=medium

  * debian/*install: Add pkg-config file
  * debian/*install: multiarchify files
  * debian/patches/cmake.patch: fix PKGCONF_REQ_PRIVATE

 -- Nicolas Mora <nicolas@babelouest.org>  Sun, 16 Dec 2018 13:37:33 -0500

yder (1.4.4-1) unstable; urgency=medium

  * New upstream release
  * Add unit tests
  * Add autopkgtest

 -- Nicolas Mora <nicolas@babelouest.org>  Sat, 15 Dec 2018 12:43:52 -0500

yder (1.4.2-1) unstable; urgency=medium

  * New upstream release

 -- Nicolas Mora <nicolas@babelouest.org>  Fri, 12 Oct 2018 18:27:04 -0400

yder (1.4.0-1) unstable; urgency=medium

  * New upstream release

 -- Nicolas Mora <nicolas@babelouest.org>  Sun, 23 Sep 2018 09:04:52 -0400

=== debian/control ===
--- 
+++ 
@@ -5,17 +5,21 @@
 Uploaders: Thorsten Alteholz <debian@alteholz.de>
           , Nicolas Mora <nicolas@babelouest.org>
 Build-Depends: debhelper (>= 11)
+	, autopkgtest (>= 5.6~)
+	, dh-exec
 	, liborcania-dev
 	, libjansson-dev
-  , libsystemd-dev
-  , cmake
-Standards-Version: 4.1.3
+	, libsystemd-dev [linux-any]
+	, cmake
+	, check
+Standards-Version: 4.4.0
 Homepage: https://github.com/babelouest/yder
 Vcs-Browser: https://salsa.debian.org/debian-iot-team/oauth2/yder.git
 Vcs-Git: https://salsa.debian.org/debian-iot-team/oauth2/yder.git
 
 Package: libyder2.0
 Architecture: any
+Multi-Arch: same
 Section: libs
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: logging library written in C
@@ -27,12 +31,13 @@
 
 Package: libyder-dev
 Architecture: any
+Multi-Arch: same
 Section: libdevel
 Depends: libyder2.0 (= ${binary:Version})
-        , ${misc:Depends}
-        , liborcania-dev
-        , libjansson-dev
-        , libsystemd-dev
+	, ${misc:Depends}
+	, liborcania-dev
+	, libjansson-dev
+	, libsystemd-dev [linux-any]
 Description: logging library written in C - development
  Simple and easy to use logging library. You can log messages to the
  console, a file or syslog.

=== debian/rules ===
--- 
+++ 
@@ -13,6 +13,13 @@
 # package maintainers to append LDFLAGS
 #export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
 
+DEB_HOST_ARCH_OS ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)
+
+ifneq ($(DEB_HOST_ARCH_OS),linux)
+ARGS += -DWITH_JOURNALD=OFF
+else
+ARGS += -DWITH_JOURNALD=ON
+endif
 
 %:
 	dh $@ --buildsystem=cmake --builddirectory=build
@@ -21,5 +28,7 @@
 	echo dh_auto_install
 
 override_dh_auto_configure:
-	dh_auto_configure -- $(ARGS) --no-warn-unused-cli
+	dh_auto_configure -- $(ARGS) -DBUILD_YDER_TESTING=ON \
+                               -DINSTALL_HEADER=ON \
+                               --no-warn-unused-cli
 	dh_installexamples

=== debian/tests/control ===
Tests: unit-test
Depends: @, gcc, libc-dev, check, liborcania-dev, pkg-config
